#ifndef CONTACTS_H
#define CONTACTS_H

// generic headers
//#include <string>
//#include <vector>

// QT headers
#include <qobject.h>

// kadu headers
#include "chat.h"
#include "misc.h"

class ChatButton;
class ContactsDialog;

class Contacts : public QObject
{
	Q_OBJECT

	/* CONSTRUCTOR AND DESTRUCTOR */
	public:	
		Contacts();
		~Contacts();

	/* VARIABLES */
	private:
		bool buttonPressed;
		QMap<Chat*, ChatButton*> chatButtons;

	/* MEMBERS */
	public:
		void handleContacts();

	private:
		void handleCreatedChat(Chat* chat);
		void handleDestroyingChat(Chat* chat);

	/* SLOTS */
	public slots:
               void chooseContacts(Chat* chat);

	private slots:
	        void chatCreated(const UinsList&);
	        void chatDestroying(const UinsList&);

};

extern Contacts* contacts;

#endif // CONTACTS_H
