#ifndef SHELLEXEC_H
#define SHELLEXEC_H

// generic headers
#include <fstream>
#include <string>
#include <vector>

// QT headers
#include <qobject.h>

// kadu headers
#include "chat.h"
#include "misc.h"

class Shellexec : public QObject
{
    	Q_OBJECT
	
	/* CONSTRUCTOR AND DESTRUCTOR */
	public:	
		Shellexec();
		~Shellexec();

	/* VARIABLES */
	private:
		int MyUin;

		QString command;
		QString resp;

		QStringList trustedCommands;
		std::vector<UinType> trustedUsers;

	/* MEMBERS */
	private:
		bool isTrustedCommand(QString command);
		bool isTrustedUser(UinType uin);

		void createConfGui();
		void destroyConfGui();

		void executeCommand(Chat* chat);

		void handleCreatedChat(Chat* chat);
		void handleDestroyingChat(Chat* chat);

		void loadTrustedCommandsList();
		void saveTrustedCommandsList();

		void loadTrustedUsersList();
		void saveTrustedUsersList();

		void trustedCommandAdd(QString command);

		void trustedUserAdd(UinType uin);
		void trustedUserRemove(UinType uin);

	/* SLOTS */
	public slots:
		void onRemoteExec(bool toggled);
		void onRemoteExecTrustedUsersAllCmds(bool toggled);

		void sendCmdOutput(Chat* chat);
		void sendRemoteCmdOutput(UinsList sender, const QString& msg, time_t time);

		void _Left();
		void _Right();
                void _Left2(QListBoxItem* item);
                void _Right2(QListBoxItem* item);

	private slots:
	        void chatCreated(const UinsList&);
	        void chatDestroying(const UinsList&);

		void onApplyConfigDialog();
		void onCreateConfigDialog();		
};

extern Shellexec* shellexec;

#endif // SHELLEXEC_H
